]> git.pld-linux.org Git - packages/rpm-build-tools.git/blobdiff - builder.sh
- check for upper-case alpha|beta|pre|rc too
[packages/rpm-build-tools.git] / builder.sh
index 659f727ab3d73f67944e82d73c087402af7d6078..0c5d02e050a04f72ba1aca4e883baafdbfe1fed4 100644 (file)
@@ -3,11 +3,12 @@
 # $Id$
 # Exit codes:
 #      0 - succesful
-#      1 - help dispayed
+#      1 - help displayed
 #      2 - no spec file name in cmdl parameters
 #      3 - spec file not stored in repo
 #      4 - some source, patch or icon files not stored in repo
 #      5 - package build failed
+#      6 - spec file with errors
 
 # Notes (todo):
 #      - builder -u fetches current version first
@@ -16,6 +17,7 @@
 #      - doesn't get sources for specs with %include /usr/lib/rpm/macros.python
 #        when there's no rpm-pythonprov (rpm's fault, but it's ugly anyway)
 #      - as above with %include /usr/lib/rpm/macros.perl and no rpm-perlprov
+#      - when Icon: field is present, -5 and -a5 doesn't work
 
 VERSION="\
 Build package utility from PLD CVS repository
@@ -50,7 +52,6 @@ LOGDIR=""
 LOGDIROK=""
 LOGDIRFAIL=""
 LASTLOG_FILE=""
-LTAG=""
 CHMOD="no"
 CHMOD_MODE="0444"
 RPMOPTS=""
@@ -76,8 +77,11 @@ DEF_NICE_LEVEL=0
 
 FAIL_IF_NO_SOURCES="yes"
 
-GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES --inet"
-GETURI2="wget -c -nd -t$WGET_RETRIES --inet"
+wget --help 2>&1 | grep -q ' \-\-inet ' && WGET_OPTS="$WGET_OPTS --inet"
+wget --help 2>&1 | grep -q ' \-\-retry\-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
+
+GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
+GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
 GETLOCAL="cp -a"
 
 if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
@@ -108,7 +112,8 @@ Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
        [-h|--help] [--http] [{-l,--logtofile} <logfile>] [-m|--mr-proper]
        [-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T--tag <cvstag>]
        [-Tvs|--tag-version-stable] [-Tvn|--tag-version-nest]
-       [-Ts|--tag-stable] [-Tn|--tag-nest] [-Tv|--tag-version]
+       [-Ts|--tag-stable] [-Tn|--tag-nest] [-Tv|--tag-version] 
+       [{-Tp|--tag-prefix} <prefix>]
        [-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>]
        [--with/--without <feature>] [--define <macro> <value>] <package>[.spec]
 
@@ -134,6 +139,7 @@ Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
                        - setup \$CVSROOT,
        --define <macro> <value>
                        - define a macro <macro> with value <value>,
+       --nodeps        - rpm won't check any dependences
        -g, --get       - get <package>.spec and all related files from
                          CVS repo or HTTP/FTP,
        -h, --help      - this message,
@@ -174,6 +180,8 @@ Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
                        - add cvs tag NEST for files,
        -Tv, --tag-version
                        - add cvs tag NAME-VERSION-RELESE for files,
+       -Tp, --tag-prefix <prefix>
+                       - add <prefix> to NAME-VERSION-RELEASE tags,
        -v, --verbose   - be verbose,
        -u, --try-upgrade
                        - check version, and try to upgrade package
@@ -189,15 +197,23 @@ Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
 "
 }
 
-rpm_dump () {
+cache_rpm_dump () {
+   rpm_dump_cache=`
        case "$RPMBUILD" in
        rpm )
                rpm -bp --nodeps --define 'prep %dump' $BCOND $SPECFILE 2>&1 
                ;;
        rpmbuild )
-               rpmbuild --define 'prep %dump' $BCOND $SPECFILE 2>&1 
+               rpmbuild --nodigest --nosignature --define 'prep %dump' $BCOND $SPECFILE 2>&1 
                ;;
-       esac
+       esac`
+}
+
+rpm_dump () {
+    if [ -z "$rpm_dump_cache" ] ; then
+       echo "internal error: cache_rpm_dump not called!" 1>&2
+    fi
+    echo "$rpm_dump_cache"
 }
 
 parse_spec()
@@ -208,6 +224,9 @@ parse_spec()
     fi
 
     cd $SPECS_DIR
+
+    cache_rpm_dump
+
     if [ "$NOSRCS" != "yes" ]; then
        SOURCES="`rpm_dump | awk '/SOURCEURL[0-9]+/ {print $3}'`"
     fi
@@ -317,7 +336,7 @@ get_spec()
            result=$?
            [ -n "$output" ] && echo "$output"
            if [ "$result" -ne "0" ]; then
-               if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out)") && [ "$retries_counter" -le "$CVS_RETRIES" ]; then
+               if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$retries_counter" -le "$CVS_RETRIES" ]; then
                    echo "Trying again [$SPECFILE]... ($retries_counter)"
                    sleep 2
                    continue
@@ -467,10 +486,13 @@ get_files()
                            if [ `echo $url | grep -E 'ftp://'` ]; then
                                ${GETURI2} -O "$target" "$url"
                            fi
-                       test -s "$target" || rm -f "$target"
+                       if ! test -s "$target"; then
+                           rm -f "$target"
+                           FROM_DISTFILES=0
+                       fi
                    fi
-               elif [ -z "$(src_md5 "$i")" ] && \
-                    ( [ -z "$NOCVS" ] || echo $i | grep -qvE '(ftp|http|https)://' ); then
+               elif [ -z "$(src_md5 "$i")" -a "$NOCVS" != "yes" ]; then
+                   # ( echo $i | grep -qvE '(ftp|http|https)://' ); -- if CVS should be used, but URLs preferred
                    result=1
                    retries_counter=0
                    while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
@@ -478,7 +500,7 @@ get_files()
                        output=$(LC_ALL=C cvs $OPTIONS `nourl $i` 2>&1)
                        result=$?
                        [ -n "$output" ] && echo "$output"
-                       if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
+                       if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
                                echo "Trying again [`nourl $i`]... ($retries_counter)"
                                sleep 2
                                continue
@@ -564,7 +586,14 @@ tag_files()
     if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
        echo "Version: $PACKAGE_VERSION"
        echo "Release: $PACKAGE_RELEASE"
-       TAGVER=$PACKAGE_NAME-`echo $PACKAGE_VERSION | sed -e "s/\./\_/g" -e "s/@/#/g"`-`echo $PACKAGE_RELEASE | sed -e "s/\./\_/g" -e "s/@/#/g"`
+       # Check whether first character of PACKAGE_NAME is legal for tag name
+       if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
+           TAG_PREFIX=tag_
+       fi
+       TAGVER=$TAG_PREFIX$PACKAGE_NAME-`echo $PACKAGE_VERSION | sed -e "s/\./\_/g" -e "s/@/#/g"`-`echo $PACKAGE_RELEASE | sed -e "s/\./\_/g" -e "s/@/#/g"`
+       # Remove #kernel.version_release from TAGVER because tagging sources
+       # could occur with different kernel-headers than kernel-headers used at build time.
+       TAGVER=$(echo "$TAGVER" | sed -e 's/#.*//g')
        if [ "$TAG_VERSION" = "yes" ]; then
            echo "CVS tag: $TAGVER"
        fi
@@ -579,7 +608,9 @@ tag_files()
 
        cd $SOURCE_DIR
        for i in $TAG_FILES; do
-           if [ -f `nourl $i` ]; then
+           # don't tag non cvs files (ie. stored on distfiles)
+           [ "`nourl $i`" != "$i" ] && continue
+           if [ -f "`nourl $i`" ]; then
                if [ "$TAG_VERSION" = "yes" ]; then
                    cvs $OPTIONS $TAGVER `nourl $i`
                fi
@@ -650,7 +681,7 @@ build_package()
 
     if [ -n "$TRY_UPGRADE" ]; then
 
-       if [ -n "FLOAT_VERSION" ]; then
+       if [ -n "$FLOAT_VERSION" ]; then
            TNOTIFY=`./pldnotify.awk $SPECFILE -n`
        else
            TNOTIFY=`./pldnotify.awk $SPECFILE`
@@ -692,17 +723,12 @@ build_package()
            BUILD_SWITCH="-bs --nodeps" ;;
     esac
     if [ -n "$LOGFILE" ]; then
-       if [ -n "$CVSTAG" ]; then
-           LTAG="r_`echo $CVSTAG|sed -e 's/\./_/g'`_"
-       else
-           LTAG=""
-       fi
        LOG=`eval echo $LOGFILE`
        if [ -n "$LASTLOG_FILE" ]; then
            echo "LASTLOG=$LOG" > $LASTLOG_FILE
        fi
        RES_FILE=~/tmp/$RPMBUILD-exit-status.$RANDOM
-       (nice -n ${DEF_NICE_LEVEL} time $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $BCOND $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
+       (time nice -n ${DEF_NICE_LEVEL} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $BCOND $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
        RETVAL=`cat $RES_FILE`
        rm $RES_FILE
        if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
@@ -838,6 +864,9 @@ while test $# -gt 0 ; do
            TAG=""
            TAG_VERSION="yes"
            shift;;
+       -Tp | --tag-prefix )
+           TAG_PREFIX="$2"
+           shift 2;;
        -T | --tag )
            COMMAND="tag";
            shift
@@ -847,6 +876,7 @@ while test $# -gt 0 ; do
        -U | --update )
            COMMAND="get"
            UPDATE="yes"
+           NOCVSSPEC="yes"
            NODIST="yes"
            UPDATE5="yes"
            shift ;;
@@ -863,6 +893,10 @@ while test $# -gt 0 ; do
            shift 2
            RPMOPTS="${RPMOPTS} --define \"${MACRO} ${VALUE}\""
            ;;
+       --nodeps)
+           shift
+           RPMOPTS="${RPMOPTS} --nodeps"
+           ;;
        * )
            SPECFILE="`basename ${1} .spec`.spec"; shift ;;
     esac
@@ -944,6 +978,13 @@ case "$COMMAND" in
                get_files $ICONS
                parse_spec;
            fi
+           # don't fetch sources from remote locations
+           new_SOURCES=""
+           for file in $SOURCES; do
+               [ "`nourl $file`" != "$file" ] && continue
+               new_SOURCES="$new_SOURCES $file"
+           done
+           SOURCES="$new_SOURCES"
            get_files $SOURCES $PATCHES;
            tag_files "$SOURCES $PATCHES $ICONS";
        else
This page took 0.073404 seconds and 4 git commands to generate.